// File: benchmarkmodule.c

#include "<Python.h>"

static PyObject *
benchmark_generate(PyObject *self, PyObject *args)
{
  int index, number_of_arguments;
  PyObject *numberslist = NULL;
  PyObject *check_value = NULL;
  PyFloatObject *aux_float = NULL;
  double element_value;
  double minimum_value = 100;
  double maximum_value = 0;
  char *exist_check;

  if (!PyArg_ParseTuple (args, "OO", &numberslist, &check_value))
     return NULL;

  if (!PyList_Check(numberslist))
  {
    PyErr_SetString(PyExc_TypeError, "Invalid list of values !");
    return NULL;
  }

  if (!PyFloat_Check(check_value))
  {
    PyErr_SetString(PyExc_TypeError, "Invalid checking value !");
    return NULL;
  }

  number_of_arguments = PyList_Size(numberslist); 
  exist_check = "No";

  for (index=0; index<number_of_arguments; index++)
  {
     aux_float = (PyFloatObject *) PyList_GetItem(numberslist, index);
     if (!PyFloat_Check(aux_float))
     {
        PyErr_SetString(PyExc_TypeError, "Invalid list value !");
        return NULL;
     }         

     element_value = PyFloat_AsDouble(aux_float);
     if (element_value < 0 )
     {
        PyErr_SetString(PyExc_TypeError, "The values cannot be less than 0 !");
        return NULL;
     }

     if (element_value > 100 )
     {
        PyErr_SetString(PyExc_TypeError, "The values cannot be greater than 100 !");
        return NULL;
     }

     if (element_value < minimum_value)
         minimum_value = element_value;

     if (element_value > maximum_value)
         maximum_value = element_value;

     if (element_value == PyFloat_AsDouble(check_value))
         exist_check = "Yes";
  }
  return Py_BuildValue("(ffs)", minimum_value, maximum_value, exist_check );
}

static PyMethodDef benchmark_methods[] = {
      {"generate", benchmark_generate, METH_VARARGS, "Minimum Value, Maximum Value"},
      {NULL, NULL}
};

DL_EXPORT(void) initbenchmark()
{
    Py_InitModule("benchmark", benchmark_methods);
}
